'Lorenz';

function d = xdot(X,t)
    a = -8/3;
    b = -10;
    c =  28;

    x = X(1); y = X(2); z = X(3);

    d = [ a*x + y*z
          b*(y-z)
          -x*y + c*y - z];
end

t = 0:0.01:30;

r = lsode(@xdot,[1 1 1],t);

subplot(1,2,1)
plot(t,r(:,2))
xlabel('t'); ylabel('y'), 

subplot(1,2,2)
plot(r(:,1),r(:,2))
xlabel('x'); ylabel('y'), title('Lorenz')
