! Escribe una función `milog(n,x)` para calcular una aproximación a la función $\ln(x)$ mediante una aproximación numérica a la siguiente integral mediante cualquier método simple (p.ej. la regla del rectángulo) con $n$ intervalos.

! $$ \ln(x) = \int_1^x \frac{1}{t} dt $$

! Encuentra el menor valor de $n$ que consigue un error relativo menor que el 1% al calcular $ln(10)=2.3026$.

program ejer
    implicit none
    integer :: n

    print *, milog(5,10.), milog(1000,10.)
    
    n = 1

    do while( abs(milog(n,10.) - log(10.)) / log(10.) > 0.01 )
        n = n+1
    end do

    print *, n, milog(n,10.)

contains

function milog(n,x)
    real :: milog, x
    integer :: n

    real    :: t, dt
    integer :: k

    dt = (x-1)/n
    milog = 0
    do k=1,n
        t = 1 + k*dt - dt/2
        milog = milog + dt * 1/t
    end do
end function

end program
