PROGRAM gas
    use graphics
    use util
    implicit none
    integer, parameter :: n = 500
    real :: x(n),y(n),vx(n),vy(n)
    real :: dt = 1.0, aux
    logical :: choque
    real :: maxx = 640, maxy = 480

    call init_random_seed
    x  = randomsr(n,100.,200.)
    y  = randomsr(n,100.,200.)
    vx = randomsr(n,0.,1.)
    vy = randomsr(n,0.,1.)

    call pizarra(nint(maxx),nint(maxy),"simulación de gas")
    call escala(0.,maxx,0.,maxy)
    call fondo(255,255,255)
    call color(255,0,0)
    call recta(320.,0.,320.,240.)
    
    call color(0,0,0)
    call animate(run,0)

contains

subroutine run(tecla,time)
        integer :: tecla, time, k
        if(tecla /=0 .or. time > 10000) stop

        do k=1,n
            aux = x(k) + vx(k)*dt         !vemos donde caera' la bola k en eje x
            choque = aux<0 .or. aux>640
            choque = choque .or. x(k) < 320 .and. aux > 320 .and. y(k) < 240
            choque = choque .or. x(k) > 320 .and. aux < 320 .and. y(k) < 240
            if(choque) then
                vx(k) = -vx(k)                 !si se va a salir cambiamos de sentido
            else
                x(k) = aux                        !si no seguimos avanzando
            end if

            aux = y(k) + vy(k)*dt           !vemos donde caera' la bola k en eje y
            if(aux<0 .or. aux>480) then
                vy(k) = -vy(k)                    !si se va a salir cambiamos de sentido
            else
                y(k) = aux                        !si no seguimos avanzando
            end if

            call circunferencia(x(k),y(k),2.)
        end do
    end subroutine

END program

