PROGRAM koch
    use graphics
    implicit none
    integer :: n=3

    call pizarra(600,600,"Koch")
    call autoescala(-3.,3.,0.)
    call fondo(0,32,0)
    
    call color(255,255,0)
    call go([-2.,0.],[2.,0.],n)

    call esperatecla

contains

    recursive subroutine go(p,q,nivel)
        real :: p(2), q(2)
        integer nivel

        real :: d(2), a(2), b(2), c(2)

        if (nivel==0) then
            call recta(p(1),p(2),q(1),q(2))
        else
            d = (q-p)/3
            a = p + d
            c = q - d
            b = (p+q)/2 + [-d(2),d(1)]*sin(60*pi/180)
            call go(p,a,nivel-1)
            call go(a,b,nivel-1)
            call go(b,c,nivel-1)
            call go(c,q,nivel-1)
        endif

    end subroutine

END

