program main
    use graphics
    use util
    implicit none
    integer :: n1=3, n2=3, s1=2, s2=3
    integer, parameter :: m=100
    logical :: world(0:m-1,0:m-1)=.False., aux(0:m-1,0:m-1) = .False.
    integer :: i,j
    call mainprogram
contains 

    subroutine mainprogram

    call init_random_seed    
    world = reshape( [ (bernoulli(0.3), i=1,m*m) ],  [ m, m ] )
    call pizarra(500,500, "the game of life ")    
    call escala(0.,real(m),0.,real(m))
    call animate(run,1000/10)

    end
    
    subroutine run(tecla,time)
        integer :: tecla, time
        if(tecla /=0 .or. time > 10000) stop
        do i=0,m-1
            do j=0,m-1
                aux(i,j) = siguiente(i,j)
            end do
        end do
        world = aux
        call pintaArray
    end subroutine

    function siguiente(i,j)
        logical :: siguiente
        integer :: i,j, k, l, vec
        vec = 0
        do k=i-1,i+1
            do l = j-1,j+1
                if (world(modulo(k,m),modulo(l,m))) vec = vec+1 
            end do
        end do
        if (world(i,j)) then
            siguiente = s1<=vec-1 .and. vec-1 <= s2
        else
            siguiente = n1 <= vec .and. vec <= n2
        end if
    end function
    
    subroutine pintaArray
        integer :: i,j
        do i=0,m-1
            do j=0,m-1
                if (world(i,j)) then
                    call color (255,255,255)
                else
                    call color(0,0,0)
                end if
                call rectangulo(real(i),real(j),real(i+1),real(j+1))
            end do
        end do
    end subroutine

END
