program main
    use graphics
    implicit none
    real, parameter :: G=1., Ms=1., dt=1E-2
    real :: x=4., y=0., vx = 0.1, vy=0.3, ax, ay, t=0.
    call mainprogram
contains

    subroutine model()
        real :: r, a
        r = sqrt(x*x+y*y)
        a = -G*Ms/r**2
        ax = a*x/r
        ay = a*y/r
    end subroutine

    subroutine mainprogram
        call pizarra(500,500,"Newton")
        call autoescala(-6.,6.,0.)
        call fondo(255,255,255)
    
        call color(255,255,0)
        call circulo(0.,0.,0.4)
        call color(255,0,0)
         
        do while(t<20)
            call model()
            call punto(x,y)
            vx = vx + ax*dt
            vy = vy + ay*dt
            x  = x + vx*dt
            y  = y + vy*dt
            t  = t + dt
        end do
        
        call esperatecla
    end    
end

