PROGRAM gas
    use graphics
    use util
    implicit none

    real :: dt = 0.05, k = 10, f=0.01
    integer :: fps = 100
    real :: x(100)
    real :: u(100) = 0
    real :: v(100) = 0
    x = seq(100)
    u= 1.5*exp(-((x-30)/4)**2)

    call pizarra(800,300,"ecuación de onda")
    call escala(-7.,107.,-1.8,1.8)
    call fondo(255,255,255) 
    call color(200,200,200)
    call ejes(10.,0.5)
    call animate(run,1000/fps)

contains

subroutine run(tecla,time)
        integer :: tecla, time
        if(tecla /=0 .or. time >10*fps) stop
        v = v+dt*(k*lap(u)-f*v)
        v(1:2) = 0; v(99:100) = 0
        u = u+dt*v
        u(1:2) = 0; u(99:100) = 0
        call color(128,128,128); call plot(x,v)
        call color(0,0,0); call plot(x,u)
    end subroutine

function lap(x)
    real :: x(:), lap(size(x))
    integer :: k
    do k = 3,98
        !lap(k) = x(k-1)+x(k+1)-2*x(k)
        lap(k) = dot_product(x(k-2:k+2),[-1./12,4./3,-5./2,4./3,-1./12])
    end do
    lap(1:2) = lap(3)
    lap(99:100) = lap(98)
end function

END program

