PROGRAM gas
    use graphics
    use util
    implicit none

    integer, parameter :: m=100
    real :: r(m)
    real :: x(m,m), y(m,m), u(m,m), v(m,m)
    integer :: i,j
    real :: dt=0.02, f=0.05, k=20
    real :: w = 4
    r = seq(m)
    x = reshape([ (seq(m), j=1,m) ], [m,m])
    y = transpose(x)
    u = 2*1.5*exp(-0.5*(((x-30)/w)**2+((y-40)/w)**2))
    v = 0
    
    call pizarra(500,500, "waveeq2d")    
    call escala(0.,real(m),0.,real(m))

    call animate(run,0)

contains

    subroutine run(tecla,time)
        integer :: tecla, time
        if (tecla /=0) print *, tecla
        if (tecla == 115) call frame_skip(10)
        if (tecla == escape_key .or. time >10000) stop
        if (tecla == mouse) then
            u = u + 2*1.5*exp(-0.5*(((x-mouse_x)/w)**2+((y-mouse_y)/w)**2))
        end if

        v = v+dt*(k*laplacian(u)-f*v)
        u = u+dt*v

        call pintaArray(u)
    end subroutine

function laplacian(x)
    real :: x(:,:), laplacian(size(x,1),size(x,2))
    real :: mask(9) = [0.5, 1.0, 0.5, 1.0, -6., 1.0, 0.5, 1.0, 0.5]
    laplacian = 0
    do i=1+1,size(x,1)-1
            do j=1+1,size(x,2)-1
                laplacian(i,j) = dot_product(mask, [x(i-1,j-1),x(i-1,j),x(i-1,j+1), &
                                                    x(i,j-1),x(i,j),x(i,j+1), &
                                                    x(i+1,j-1),x(i+1,j),x(i+1,j+1)])
            end do
        end do

end function

subroutine pintaArray(m)
        real :: m(:,:)
        integer :: i,j
        do i=1,size(m,1)
            do j=1,size(m,2)
                call heatcolor(m(i,j),-1.,0.,1.)
                !call graycolor(m(i,j),-1.,1.)
                call rectangulo(real(i-1),real(j-1),real(i),real(j))
            end do
        end do
    end subroutine

END program

