program random
    implicit none
    integer k
    call init_random_seed
    do k=0,10
        print *, random_integer(1,6)
    end do

contains

    SUBROUTINE init_random_seed()
        INTEGER :: i, n, clock
        INTEGER, DIMENSION(:), ALLOCATABLE :: seed

        CALL RANDOM_SEED(size = n)
        ALLOCATE(seed(n))

        CALL SYSTEM_CLOCK(COUNT=clock)

        seed = clock + 37 * (/ (i - 1, i = 1, n) /)
        CALL RANDOM_SEED(PUT = seed)
        DEALLOCATE(seed)
    END SUBROUTINE
    
    function random_real(a,b)
        real a,b,random_real
        real x
        call random_number(x)
        random_real = (b-a)*x+a
    end function
    
    function random_integer(a,b)
        integer :: a,b,random_integer
        real :: x
        call random_number(x)
        random_integer = a + FLOOR((b-a+1)*x) 
    end function
    
end program
