
PROGRAM binary_search
    implicit none
    real :: x
    
    x = root(f,0.,1.)
    print *, x, f(x)
    
    x = root(g,0.,1.)
    print *, x, g(x)

contains    

    function f(x)
        real :: f,x
        f = sin(x) - cos(3*x)
    end function f

    function g(x)
        real :: g,x
        g = sin(cos(3*x))*exp(x**2)
    end function g

    recursive function root(g,a,b) result(r)
        real :: r,a,b,c
        interface
            function g(x)
                real :: g,x
            end function
        end interface

        c = (a+b)/2
        if (abs(a-b) < 0.0001) then
            r = c
        else
            if (g(a)*g(c)<0) then
                r = root(g,a,c)
            else
                r = root(g,c,b)
            endif
        endif
    end function root

end program


