PROGRAM propiedad_de_la_traza
    implicit none

    real :: a(4,4), b(4,4)
    call read_matrix(a,"c1.txt")
    print *, "a:"
    call show_matrix('(F7.2)',a)
    
    call read_matrix(b,"c2.txt")
    print *, "b:"
    call show_matrix('(F7.2)',b)
    
    print *, "ab"
    call show_matrix('(F7.2)',matmul(a,b))
    print *, "ba"
    call show_matrix('(F7.2)',matmul(b,a))
    
    print *, "comprobamos la propiedad:"
    print *, "traza(ab)", sum(diag(matmul(a,b)))
    print *, "traza(ba)", sum(diag(matmul(b,a)))
    
contains 

function diag(m)
    real m(:,:), diag(size(m,1))
    integer k
    do k=1,size(diag)
        diag(k) = m(k,k)
    end do
end function

subroutine read_matrix(m, arch)
    integer, parameter :: u = 10
    real :: m(:,:), mt(size(m,2),size(m,1))
    character (LEn=*)  :: arch
    
    open(unit=u, file=arch, action="read")
    read (unit=u, fmt=*) mt
    m = transpose(mt)
end subroutine
    
subroutine show_matrix(f,m)
    real :: m(:,:)
    character (LEn=*)  :: f
    integer r,c,i,j
    r = size(m,1)
    c = size(m,2)
    
    do i = 1,r
        do j = 1,c
            write (*,f,advance='no') m(i,j)
        end do
        print *
    end do
    
end subroutine
    
END program
