#include <SDL2/SDL.h>
#include <SDL2/SDL2_gfxPrimitives.h>
#include <stdio.h>
#include <time.h>

SDL_Window *window;
int gogogo;
SDL_Event event;
SDL_Renderer* renderer;
SDL_Texture* backg;

Sint16 cr=255, cg=255, cb=255, ca=255;
Sint16 br=0,   bg=0,   bb=0,   ba=255;

double xSm, ySm, xSb, ySb;   // coeficientes de escala
double xS1, xS2, yS1, yS2;   // extremos de la pantalla
//double xSpc,ySpc;          // % de ancho de pantalla
double ySc;                  // centro y 
double xA,yA;                // puntos de dibujo anteriores
double aA;                   // ángulo anterior
int lastx, lasty;
int ww,wh;                   // tamaño de la ventana

void CentroY(double yc) {
    ySc = yc; 
}

int xS(double x) {
    return (x*xSm+xSb); 
}

int yS(double y) {
    return (y*ySm+ySb); 
}

void escala(double x1, double x2, double y1, double y2) { 
    if(!(x2>x1 && y2>y1)) {
        printf("ERROR: Problemas con la EscalaDibujo deseada\n");
        exit(1);
    }

    xSm = ww/(x2-x1);
    xSb = ww*x1/(x1-x2)+.5;
    ySm = wh/(y1-y2);
    ySb = wh*y2/(y2-y1)+.5;
    lastx=lasty=0; 
    xA = 0; yA = 0; aA = 0;
    xS1=x1; xS2=x2; yS1=y1; yS2=y2;
    //  xSpc = (xS2-xS1)/200.;
    //  ySpc = 4*(yS2-yS1)/600.;
}



void autoescala(double min, double max, double yc){
    CentroY(yc);

    double ancho = max-min;
    if(max<=min) {
        printf("Problemas con la AutoEscala seleccionada\n");
        exit(1);
    }
    min-=ancho*7/100;
    max+=ancho*5/100;
    ancho = max-min; 

    double ar = (double)wh/ww/2;
    escala(min,max,-(max-min)*ar+ySc,(max-min)*ar+ySc); 
 }

void (* fzoom) (void) = NULL;

void zoom_(double *s) {
    double dx = (xS2-xS1)/2*(1-1/(*s));
    double dy = (yS2-yS1)/2*(1-1/(*s));
    escala(xS1+dx,xS2-dx,yS1+dy,yS2-dy);
    if(fzoom) (*fzoom)();
}

void zoomcenter_(double *x, double *y) {
    double dx = (xS2-xS1)/2;
    double dy = (yS2-yS1)/2;
    escala(*x-dx,*x+dx,*y-dy,*y+dy);
    //if(fzoom) (*fzoom)();
}

void onzoom(void fun()){
    fzoom = fun;
}

////////////////////////////////////////////////////////////////////////////////

void pizarra(int w,int h,char*title) {
    SDL_Init(SDL_INIT_VIDEO);              // Initialize SDL2
    window = SDL_CreateWindow(
        title,                             // window title
        SDL_WINDOWPOS_UNDEFINED,           // initial x position
        SDL_WINDOWPOS_UNDEFINED,           // initial y position
        ww=w,                              // width, in pixels
        wh=h,                              // height, in pixels
        SDL_WINDOW_OPENGL                  // flags - see below
    );

    // Check that the window was successfully created
    if (window == NULL) {
        // In the case that the window could not be made...
        printf("Could not create window: %s\n", SDL_GetError());
        exit(1);
    }

    renderer = SDL_CreateRenderer(window, -1, 0);
    backg = SDL_CreateTexture(renderer, SDL_PIXELFORMAT_RGBA8888, SDL_TEXTUREACCESS_TARGET, ww, wh);
    SDL_SetRenderTarget(renderer, backg);

    SDL_SetRenderDrawColor(renderer, 48, 0, 0, 255);
    SDL_RenderClear(renderer);
    //SDL_RenderPresent(renderer);

    autoescala(-1,1,0);
}

void findibujo_(){
    SDL_DestroyWindow(window);
    SDL_Quit();
}


void pausa_(int*ms){
    SDL_Delay(*ms);
}

void refresh_(){
    SDL_RenderPresent(renderer);
}

void color(int r,int g,int b){
    cr = r; cg = g; cb = b;
    SDL_SetRenderDrawColor(renderer, cr,cg,cb,ca);
}


void tinta_(int*t) {
    ca = *t;
}


#define MIN(a,b) ((a)<(b)?(a):(b))
#define MAX(a,b) ((a)>(b)?(a):(b))
void heatcolor(double h, double hmin, double hzero, double hmax){
    int v;
    if (h > hzero) {
        v = MIN(255,(h-hzero)*255/hmax);
        color(255,255-v,255-v);
    } else {
        v = MIN(255,(h-hzero)*255/hmin);
        color(255-v,255-v,255);
    }
}

void graycolor(double h, double hmin, double hmax){
    int v = MIN(255,MAX(0,(h-hmin)/(hmax-hmin)*255));
    color(v,v,v);
}


void line_(int*x1,int*y1,int*x2,int*y2){
    SDL_RenderDrawLine(renderer,*x1,*y1,*x2,*y2);
}


void thickline_(int*x1,int*y1,int*x2,int*y2,int*lw){
    thickLineRGBA(renderer,*x1,*y1,*x2,*y2,*lw,cr,cg,cb,ca);
}

void recta(double x1, double y1, double x2, double y2){
    //thickLineRGBA(renderer,xS(*x1),yS(*y1),lastx=xS(*x2),lasty=yS(*y2),*lw,cr,cg,cb,ca);
    aalineRGBA(renderer,xS(x1),yS(y1),lastx=xS(x2),lasty=yS(y2),cr,cg,cb,ca);  
    xA=x2; yA=y2;
    //aA = atan2(y2-y1,x2-x1)/(3.141592654/180);
}


void rectangulo(double x1, double y1, double x2, double y2){
    boxRGBA(renderer,xS(x1),yS(y1),xS(x2),yS(y2),cr,cg,cb,ca);
}


void punto(double x, double y){
     pixelRGBA(renderer,lastx=xS(xA=x),lasty=yS(yA=y),cr,cg,cb,ca);
     aA = 0; 
}

void rpixel(int x, int y, int r, int g, int b){
    pixelRGBA(renderer,x,y,r,g,b,ca); 
}

void rectaa(double x, double y){
     recta(xA,yA,x,y); 
}


void avanza(double d) {
    rectaa(xA+d*cos(aA),yA+d*sin(aA));
}

void gira(double a) {
    aA = aA + a * (3.141592654/180);
}


void circunferencia(double x1,double y1,double r){
    if (r<=0) return;
    Sint16 R = round(r*xSm);
    if(R>1) {
        aacircleRGBA(renderer,xS(x1),yS(y1),R,cr,cg,cb,ca);
    } else if (R==1) {
        circleRGBA(renderer,xS(x1),yS(y1),R,cr,cg,cb,ca);
    } else {
        pixelRGBA(renderer,xS(x1),yS(y1),cr,cg,cb,ca);
    }
}

void circulo(double x1,double y1,double r){
    if (r<=0) return;
    Sint16 R = round(r*xSm);
    if(R>1) {
        filledCircleRGBA(renderer,xS(x1),yS(y1),R,cr,cg,cb,ca);
        aacircleRGBA(renderer,xS(x1),yS(y1),R,cr,cg,cb,ca);
    } else if (R==1) {
        circleRGBA(renderer,xS(x1),yS(y1),R,cr,cg,cb,ca);
        pixelRGBA(renderer,xS(x1),yS(y1),cr,cg,cb,ca);
    } else {
        pixelRGBA(renderer,xS(x1),yS(y1),cr,cg,cb,ca);
    }
}

void trigon(double x1, double y1, double x2, double y2, double x3, double y3){
    filledTrigonRGBA(renderer,xS(x1),yS(y1),xS(x2),yS(y2),xS(x3),yS(y3),cr,cg,cb,ca);
    aatrigonRGBA(renderer,xS(x1),yS(y1),xS(x2),yS(y2),xS(x3),yS(y3),cr,cg,cb,ca);
}


void fondo(int r,int g,int b){
    br = r; bg = g; bb = b; ba = 255;
    SDL_SetRenderDrawColor(renderer, br, bg, bb, ba);
    SDL_RenderClear(renderer);
}

void texto(double x, double y, char* s) {
    stringRGBA(renderer,xS(x),yS(y),s,cr,cg,cb,ca);
}

void textow(int x, int y, char* s) {
    stringRGBA(renderer,x,y,s,cr,cg,cb,ca);
}

char sn[10];
char * show(char * fmt, double r) {
    snprintf(sn,9,fmt,r);
    return sn;
}

void ejes(double ax, double ay){
    if (ax<0 || ay<0) {
        printf("Error: espaciado negativo en los ejes.");
        exit(1);
    } 
    double x,y,a,b;
    a = ax; b = ay/5;    


    for (x=a; x<=xS2; x+=a) {
        aalineRGBA(renderer,xS(x),yS(0),xS(x),yS(0)+5,cr,cg,cb,ca);  
        stringRGBA(renderer,xS(x)-10,yS(0)+10,show("%.1f",x),cr,cg,cb,ca);
    }
    for (x=-a; x>=xS1; x-=a) {
        aalineRGBA(renderer,xS(x),yS(0),xS(x),yS(0)+5,cr,cg,cb,ca);  
        stringRGBA(renderer,xS(x)-20,yS(0)+10,show("%.1f",x),cr,cg,cb,ca);
    }
    for (x=0; x<=xS2; x+=a) {
        for (y=0; y<=yS2; y+=b) punto(x,y);
        for (y=-b; y>=yS1; y-=b) punto(x,y);
    }
    for (x=-a; x>=xS1; x-=a){
        for (y=0; y<=yS2; y+=b) punto(x,y);
        for (y=-b; y>=yS1; y-=b) punto(x,y);
    }



    a = ay; b = ax/5;
    for (y=a; y<=yS2; y+=a) {
        aalineRGBA(renderer,xS(0),yS(y),xS(0)-5,yS(y),cr,cg,cb,ca);  
        stringRGBA(renderer,xS(0)-32,yS(y)-4,show("%.1f",y),cr,cg,cb,ca);
    }
    for (y=-a; y>=yS1; y-=a) {
        aalineRGBA(renderer,xS(0),yS(y),xS(0)-5,yS(y),cr,cg,cb,ca);  
        stringRGBA(renderer,xS(0)-40,yS(y)-4,show("%.1f",y),cr,cg,cb,ca);
    }
    for (y=0; y<=yS2; y+=a) {
        for (x=0; x<=xS2; x+=b) punto(x,y);
        for (x=-b; x>=xS1; x-=b) punto(x,y);
    }
    for (y=-a; y>=yS1; y-=a){
        for (x=0; x<=xS2; x+=b) punto(x,y); 
        for (x=-b; x>=xS1; x-=b) punto(x,y);
    }

    recta(xS1,0,xS2,0);
    recta(0,yS1,0,yS2);


}		

void onback_() {
    SDL_SetRenderTarget(renderer, backg);
}

void offback_() {
    SDL_SetRenderTarget(renderer, NULL);
}


void saveWindowRaw(char * filename) {
    SDL_Surface *sur, *info = SDL_GetWindowSurface(window);
    unsigned char pixels[info->w * info->h * info->format->BytesPerPixel];
    SDL_RenderReadPixels(renderer, &info->clip_rect, info->format->format, pixels, info->w * info->format->BytesPerPixel);
    sur = SDL_CreateRGBSurfaceFrom(pixels, info->w, info->h, info->format->BitsPerPixel, info->w * info->format->BytesPerPixel, info->format->Rmask, info->format->Gmask, info->format->Bmask, info->format->Amask);
    SDL_SaveBMP(sur,filename);
    SDL_FreeSurface(sur);
}


void saveWindow(char * filename) {
    SDL_SetRenderTarget(renderer, NULL);
    SDL_RenderCopy(renderer,backg,NULL,NULL);
    SDL_RenderPresent(renderer);

    saveWindowRaw(filename);

    SDL_SetRenderTarget(renderer, backg);
}

void save_image(int n) {
   char s[30];
   sprintf(s,"frame-%05d.bmp",n);
   saveWindow(s);
}

void screenshot(int raw) {
    time_t current_time;
    current_time = time(NULL);
    char s[50];
    strftime(s,sizeof(s),"%F_%T.bmp",localtime(&current_time));
    if(raw) {
        saveWindowRaw(s);
    } else {
        saveWindow(s);
    }
}

void load_image(char*s) {
    SDL_Surface *sur = SDL_LoadBMP(s);
    if(!sur) {
        printf("load_image error: %s\n", SDL_GetError());
    }
    SDL_Texture* tex = SDL_CreateTextureFromSurface(renderer,sur);
    SDL_RenderCopy(renderer,tex,NULL,NULL);
}


#define L_Ctrl   1073742048
#define R_Ctrl   1073742052
#define L_Shift  1073742049
#define R_Shift  1073742053
#define Alt      1073742050
#define Alt_Gr   1073742054
#define Win      1073742051
#define Menu     1073741925


int lastkey = 0;

void esperatecla_(){
    SDL_SetRenderTarget(renderer, NULL);
    SDL_RenderCopy(renderer,backg,NULL,NULL);
    SDL_RenderPresent(renderer);

    gogogo = 1;
    while (gogogo) {
        SDL_WaitEvent(&event);
        if (   event.type == SDL_QUIT || (event.type == SDL_KEYDOWN )) {
            gogogo = 0;
            if (event.type == SDL_QUIT) {
                lastkey = 27;
            } else {
                lastkey = event.key.keysym.sym;
            }
            if (lastkey == Alt_Gr) {
                gogogo = 1;
                screenshot(0);
            }
        }
    }
    SDL_SetRenderTarget(renderer, backg);
}

int k_control=0, k_shift=0, k_alt=0;

int keymodif(int code) {
    switch(event.key.keysym.sym) {
        case L_Ctrl : k_control = 1-k_control; return 1;
        case R_Ctrl : k_control = 1-k_control; return 1;
        case L_Shift: k_shift   = 1-k_shift;   return 1;
        case R_Shift: k_shift   = 1-k_shift;   return 1;
        case   Alt  : k_alt     = 1-k_alt;     return 1;
    }
    return 0;
}

int modif_state(int k) {
    switch(k) {
        case 1: return k_control;
        case 2: return k_shift;
        case 3: return k_alt;
    }
    printf("error modif_state code\n"); exit(1);
}


double mouse_x;
double mouse_y;
int    mouse_col;
int    mouse_row;

double xcol(int c) {
    return (c-xSb)/xSm;
}

double yrow(int r) {
    return (r-ySb)/ySm;
}


void dibuja(void*callback(int*k)) {
    gogogo = 1;
    SDL_SetRenderTarget(renderer, NULL);
    SDL_RenderCopy(renderer,backg,NULL,NULL);
    int zero = 0;
    callback(&zero);
    SDL_RenderPresent(renderer);
    while (gogogo) {
        SDL_WaitEvent(&event);
        if (   event.type == SDL_QUIT
            || (event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_ESCAPE)
           ) {
            gogogo = 0;
        }
        int km;
        if (event.type == SDL_KEYUP) {
            km = keymodif(event.key.keysym.sym);
        }
        if (event.type ==  SDL_MOUSEBUTTONDOWN) {
                mouse_col = event.button.x;
                mouse_row = event.button.y;
                mouse_x   = xcol(mouse_col);
                mouse_y   = yrow(mouse_row);
                event.type = SDL_KEYDOWN;
                event.key.keysym.sym = -1;
            }
        if (event.type ==  SDL_MOUSEWHEEL) {
                event.type = SDL_KEYDOWN;
                if(event.wheel.y > 0) {
                    event.key.keysym.sym = -2;
                } else {
                    event.key.keysym.sym = -3;
                }
            }
        if (event.type == SDL_KEYDOWN) {
            km = keymodif(event.key.keysym.sym);
            if(km == 0) {
                SDL_RenderCopy(renderer,backg,NULL,NULL);
                callback((int*)&event.key.keysym.sym);
                SDL_RenderPresent(renderer);
            }
        }
    }

}

int frameskip = 1;

void set_frame_skip(int s) {
    frameskip = s<1 ? 1 : s;
}

int step = 0;

void set_step() {
    step = 1;
}

void animate(void*callback(int*k,int*t), int p) {
    int time = 0;
    gogogo = 1;
    SDL_SetRenderTarget(renderer, NULL);
    while (gogogo) {
        
        int key = 0;

        while (SDL_PollEvent(&event)) {

           if ( event.type == SDL_QUIT
                || (event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_ESCAPE)
               ) {
                gogogo = 0;
            } else if (event.type == SDL_KEYDOWN) {
                key = event.key.keysym.sym;
            } else if (event.type ==  SDL_MOUSEBUTTONDOWN) {
                key = -1;
                mouse_col = event.button.x;
                mouse_row = event.button.y;
                mouse_x   = xcol(mouse_col);
                mouse_y   = yrow(mouse_row);
            } else if (event.type ==  SDL_MOUSEWHEEL) {
                if(event.wheel.y > 0) {
                    key = -2;
                } else {
                    key = -3;
                }
            }
        }
        if(key==32 || step==1) {
            int wait = 1;
            while (wait) {
                SDL_WaitEvent(&event);
                if ( event.type == SDL_KEYDOWN ) {
                    key = event.key.keysym.sym;
                    if(key == Alt_Gr) {
                        screenshot(1);
                    } else {
                        if (key != 32) {
                            step = key = wait = 0;
                        } else {
                            key = wait = 0;
                            step = 1;
                        }
                    }
                }
            }
        }

        SDL_RenderCopy(renderer,backg,NULL,NULL);

        callback(&key,&time);

        stringRGBA(renderer,5,5,show("%.0f",time),64,64,128+64,128);
        if (time%frameskip==0) {
            SDL_RenderPresent(renderer);
        }
        SDL_Delay(p);
        time++;
        if (key == Alt_Gr) {
            screenshot(1);
        }
    }
}


void esperaclick_(){
    SDL_SetRenderTarget(renderer, NULL);
    SDL_RenderCopy(renderer,backg,NULL,NULL);
    SDL_RenderPresent(renderer);

    gogogo = 1;
    while (gogogo) {
        SDL_WaitEvent(&event);
        if (event.type ==  SDL_MOUSEBUTTONDOWN) {
            gogogo = 0;
            mouse_col = event.button.x;
            mouse_row = event.button.y;
            mouse_x   = xcol(mouse_col);
            mouse_y   = yrow(mouse_row);
        }
    }
    SDL_SetRenderTarget(renderer, backg);
}

