MODULE util
    implicit none

CONTAINS
    
    function seq(n)
        integer :: n
        real :: seq(n)
        integer :: k
        seq = [ ( k, k=1,n) ]
    end function
   
    function linspace(a,b,n)
        integer :: n
        real :: a, b, linspace(n)
        linspace = a + (b-a)/(n-1)*(seq(n)-1)
    end function    

    function norm(x)
        real :: norm, x(:)
        norm = sqrt(dot_product(x,x))
    end function

!-------------------------------------------------------------------------------

    function opcional_entero(nombre,valor)
        character(LEN=*) :: nombre
        integer          :: opcional_entero, valor

        character*30     :: aux
        integer          :: k,l
        opcional_entero = valor
        do k = 1,iargc()
            call getarg(k,aux)
            if (index(aux,nombre//"=")==1) then
                l = len(nombre)
                aux(1:l+1) = ' '
                read (aux,*) opcional_entero
                return
            end if
        end do
    end function


    function opcional_real(nombre,valor)
        character(LEN=*) :: nombre
        real             :: opcional_real, valor

        character*30     :: aux
        integer          :: k,l
        opcional_real = valor
        do k = 1,iargc()
            call getarg(k,aux)
            if (index(aux,nombre//"=")==1) then
                l = len(nombre)
                aux(1:l+1) = ' '
                read (aux,*) opcional_real
                return
            end if
        end do
    end function

!--------------------------------------------------------------------
    
    SUBROUTINE init_random_seed()
        INTEGER :: i, n, clock
        INTEGER, DIMENSION(:), ALLOCATABLE :: seed

        CALL RANDOM_SEED(size = n)
        ALLOCATE(seed(n))

        CALL SYSTEM_CLOCK(COUNT=clock)

        seed = clock + 37 * (/ (i - 1, i = 1, n) /)
        CALL RANDOM_SEED(PUT = seed)
        DEALLOCATE(seed)
    END SUBROUTINE
    
    function random_real(a,b)
        real :: a,b,random_real
        real :: x
        call random_number(x)
        random_real = (b-a)*x+a
    end function
    
     function random_integer(a,b)
        integer :: a,b,random_integer
        real :: x
        call random_number(x)
        random_integer = a + FLOOR((b-a+1)*x) 
    end function
    
    function randomsi(n,a,b)
        integer :: n,a,b,k
        integer :: randomsi(n)
        randomsi = [ (random_integer(a,b), k=1,n) ]
    end function
    
    function randomsr(n,a,b)
        integer :: n,k
        real    :: a,b, randomsr(n)
        randomsr = [ (random_real(a,b), k=1,n) ]
    end function
   
   function bernoulli(p)
        logical :: bernoulli
        real :: p, x
        call random_number(x)
        bernoulli = x < p
   end function

END

